package com.ruoyi.system.service;

import com.ruoyi.common.core.domain.entity.TbSysArea;
import com.ruoyi.system.domain.vo.AreaResultDTO;
import com.ruoyi.system.domain.vo.AreaTreeResultDTO;

import java.util.List;

/**
 * 区域Service接口
 *
 * @author ruoyi
 * @date 2023-08-01
 */
public interface ITbSysAreaService
{
    /**
     * 查询区域
     *
     * @param id 区域主键
     * @return 区域
     */
    public TbSysArea selectTbSysAreaById(Long id);

    /**
     * 查询区域列表
     *
     * @param tbSysArea 区域
     * @return 区域集合
     */
    public List<TbSysArea> selectTbSysAreaList(TbSysArea tbSysArea);

    /**
     * 查询区域树
     * @return
     */
//    public List<AreaResultDTO> getAreaTree(Integer mapArray);
    public List<AreaResultDTO> getAreaTree();


    List<AreaTreeResultDTO> areaTree();

    /**
     * 新增区域
     *
     * @param tbSysArea 区域
     * @return 结果
     */
    public int insertTbSysArea(TbSysArea tbSysArea);

    /**
     * 修改区域
     *
     * @param tbSysArea 区域
     * @return 结果
     */
    public int updateTbSysArea(TbSysArea tbSysArea);

    /**
     * 批量删除区域
     *
     * @param ids 需要删除的区域主键集合
     * @return 结果
     */
    public int deleteTbSysAreaByIds(Long[] ids);

    /**
     * 删除区域信息
     *
     * @param id 区域主键
     * @return 结果
     */
    public int deleteTbSysAreaById(Long id);

    /**
     * 统计生产区域数量：企业下
     * @param companyCode 企业编码
     * @return
     */
    Integer selectAreaCount(String companyCode);

}
